Package org.optaplanner.core.impl.score.stream.drools.quad

## Class DroolsGroupingQuadConstraintStream<Solution_,​NewA,​NewB,​NewC,​NewD>

- java.lang.Object
- - org.optaplanner.core.impl.score.stream.common.AbstractConstraintStream<Solution_>
  - - org.optaplanner.core.impl.score.stream.drools.common.DroolsAbstractConstraintStream<Solution_>
    - - org.optaplanner.core.impl.score.stream.drools.quad.DroolsAbstractQuadConstraintStream<Solution_,​NewA,​NewB,​NewC,​NewD>
      - - org.optaplanner.core.impl.score.stream.drools.quad.DroolsGroupingQuadConstraintStream<Solution_,​NewA,​NewB,​NewC,​NewD>

- All Implemented Interfaces:
    `ConstraintStream`, `QuadConstraintStream<NewA,​NewB,​NewC,​NewD>`, `InnerQuadConstraintStream<NewA,​NewB,​NewC,​NewD>`

      public final class DroolsGroupingQuadConstraintStream<Solution_,​NewA,​NewB,​NewC,​NewD>
      extends DroolsAbstractQuadConstraintStream<Solution_,​NewA,​NewB,​NewC,​NewD>

- - ### Field Summary

    - ### Fields inherited from class org.optaplanner.core.impl.score.stream.drools.common.DroolsAbstractConstraintStream

      `constraintFactory`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `DroolsGroupingQuadConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory, DroolsAbstractBiConstraintStream<Solution_,​A,​B> parent, BiFunction<A,​B,​NewA> groupKeyAMapping, BiFunction<A,​B,​NewB> groupKeyBMapping, BiFunction<A,​B,​NewC> groupKeyCMapping, BiFunction<A,​B,​NewD> groupKeyDMapping)` |
    `DroolsGroupingQuadConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory, DroolsAbstractBiConstraintStream<Solution_,​A,​B> parent, BiFunction<A,​B,​NewA> groupKeyAMapping, BiFunction<A,​B,​NewB> groupKeyBMapping, BiFunction<A,​B,​NewC> groupKeyCMapping, BiConstraintCollector<A,​B,​?,​NewD> collectorD)` |
    `DroolsGroupingQuadConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory, DroolsAbstractBiConstraintStream<Solution_,​A,​B> parent, BiFunction<A,​B,​NewA> groupKeyAMapping, BiFunction<A,​B,​NewB> groupKeyBMapping, BiConstraintCollector<A,​B,​?,​NewC> collectorC, BiConstraintCollector<A,​B,​?,​NewD> collectorD)` |
    `DroolsGroupingQuadConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory, DroolsAbstractBiConstraintStream<Solution_,​A,​B> parent, BiFunction<A,​B,​NewA> groupKeyAMapping, BiConstraintCollector<A,​B,​?,​NewB> collectorB, BiConstraintCollector<A,​B,​?,​NewC> collectorC, BiConstraintCollector<A,​B,​?,​NewD> collectorD)` |
    `DroolsGroupingQuadConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory, DroolsAbstractBiConstraintStream<Solution_,​A,​B> parent, BiConstraintCollector<A,​B,​?,​NewA> collectorA, BiConstraintCollector<A,​B,​?,​NewB> collectorB, BiConstraintCollector<A,​B,​?,​NewC> collectorC, BiConstraintCollector<A,​B,​?,​NewD> collectorD)` |
    `DroolsGroupingQuadConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory, DroolsAbstractQuadConstraintStream<Solution_,​A,​B,​C,​D> parent, QuadFunction<A,​B,​C,​D,​NewA> groupKeyAMapping, QuadFunction<A,​B,​C,​D,​NewB> groupKeyBMapping, QuadFunction<A,​B,​C,​D,​NewC> groupKeyCMapping, QuadFunction<A,​B,​C,​D,​NewD> groupKeyDMapping)` |
    `DroolsGroupingQuadConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory, DroolsAbstractQuadConstraintStream<Solution_,​A,​B,​C,​D> parent, QuadFunction<A,​B,​C,​D,​NewA> groupKeyAMapping, QuadFunction<A,​B,​C,​D,​NewB> groupKeyBMapping, QuadFunction<A,​B,​C,​D,​NewC> groupKeyCMapping, QuadConstraintCollector<A,​B,​C,​D,​?,​NewD> collectorD)` |
    `DroolsGroupingQuadConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory, DroolsAbstractQuadConstraintStream<Solution_,​A,​B,​C,​D> parent, QuadFunction<A,​B,​C,​D,​NewA> groupKeyAMapping, QuadFunction<A,​B,​C,​D,​NewB> groupKeyBMapping, QuadConstraintCollector<A,​B,​C,​D,​?,​NewC> collectorC, QuadConstraintCollector<A,​B,​C,​D,​?,​NewD> collectorD)` |
    `DroolsGroupingQuadConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory, DroolsAbstractQuadConstraintStream<Solution_,​A,​B,​C,​D> parent, QuadFunction<A,​B,​C,​D,​NewA> groupKeyAMapping, QuadConstraintCollector<A,​B,​C,​D,​?,​NewB> collectorB, QuadConstraintCollector<A,​B,​C,​D,​?,​NewC> collectorC, QuadConstraintCollector<A,​B,​C,​D,​?,​NewD> collectorD)` |
    `DroolsGroupingQuadConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory, DroolsAbstractQuadConstraintStream<Solution_,​A,​B,​C,​D> parent, QuadConstraintCollector<A,​B,​C,​D,​?,​NewA> collectorA, QuadConstraintCollector<A,​B,​C,​D,​?,​NewB> collectorB, QuadConstraintCollector<A,​B,​C,​D,​?,​NewC> collectorC, QuadConstraintCollector<A,​B,​C,​D,​?,​NewD> collectorD)` |
    `DroolsGroupingQuadConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory, DroolsAbstractTriConstraintStream<Solution_,​A,​B,​C> parent, TriFunction<A,​B,​C,​NewA> groupKeyAMapping, TriFunction<A,​B,​C,​NewB> groupKeyBMapping, TriFunction<A,​B,​C,​NewC> groupKeyCMapping, TriFunction<A,​B,​C,​NewD> groupKeyDMapping)` |
    `DroolsGroupingQuadConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory, DroolsAbstractTriConstraintStream<Solution_,​A,​B,​C> parent, TriFunction<A,​B,​C,​NewA> groupKeyAMapping, TriFunction<A,​B,​C,​NewB> groupKeyBMapping, TriFunction<A,​B,​C,​NewC> groupKeyCMapping, TriConstraintCollector<A,​B,​C,​?,​NewD> collectorD)` |
    `DroolsGroupingQuadConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory, DroolsAbstractTriConstraintStream<Solution_,​A,​B,​C> parent, TriFunction<A,​B,​C,​NewA> groupKeyAMapping, TriFunction<A,​B,​C,​NewB> groupKeyBMapping, TriConstraintCollector<A,​B,​C,​?,​NewC> collectorC, TriConstraintCollector<A,​B,​C,​?,​NewD> collectorD)` |
    `DroolsGroupingQuadConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory, DroolsAbstractTriConstraintStream<Solution_,​A,​B,​C> parent, TriFunction<A,​B,​C,​NewA> groupKeyAMapping, TriConstraintCollector<A,​B,​C,​?,​NewB> collectorB, TriConstraintCollector<A,​B,​C,​?,​NewC> collectorC, TriConstraintCollector<A,​B,​C,​?,​NewD> collectorD)` |
    `DroolsGroupingQuadConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory, DroolsAbstractTriConstraintStream<Solution_,​A,​B,​C> parent, TriConstraintCollector<A,​B,​C,​?,​NewA> collectorA, TriConstraintCollector<A,​B,​C,​?,​NewB> collectorB, TriConstraintCollector<A,​B,​C,​?,​NewC> collectorC, TriConstraintCollector<A,​B,​C,​?,​NewD> collectorD)` |
    `DroolsGroupingQuadConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory, DroolsAbstractUniConstraintStream<Solution_,​A> parent, Function<A,​NewA> groupKeyAMapping, Function<A,​NewB> groupKeyBMapping, Function<A,​NewC> groupKeyCMapping, Function<A,​NewD> groupKeyDMapping)` |
    `DroolsGroupingQuadConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory, DroolsAbstractUniConstraintStream<Solution_,​A> parent, Function<A,​NewA> groupKeyAMapping, Function<A,​NewB> groupKeyBMapping, Function<A,​NewC> groupKeyCMapping, UniConstraintCollector<A,​?,​NewD> collectorD)` |
    `DroolsGroupingQuadConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory, DroolsAbstractUniConstraintStream<Solution_,​A> parent, Function<A,​NewA> groupKeyAMapping, Function<A,​NewB> groupKeyBMapping, UniConstraintCollector<A,​?,​NewC> collectorC, UniConstraintCollector<A,​?,​NewD> collectorD)` |
    `DroolsGroupingQuadConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory, DroolsAbstractUniConstraintStream<Solution_,​A> parent, Function<A,​NewA> groupKeyAMapping, UniConstraintCollector<A,​?,​NewB> collectorB, UniConstraintCollector<A,​?,​NewC> collectorC, UniConstraintCollector<A,​?,​NewD> collectorD)` |
    `DroolsGroupingQuadConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory, DroolsAbstractUniConstraintStream<Solution_,​A> parent, UniConstraintCollector<A,​?,​NewA> collectorA, UniConstraintCollector<A,​?,​NewB> collectorB, UniConstraintCollector<A,​?,​NewC> collectorC, UniConstraintCollector<A,​?,​NewD> collectorD)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `QuadLeftHandSide<NewA,​NewB,​NewC,​NewD>` | `getLeftHandSide()` |
    `boolean` | `guaranteesDistinct()` | This method will return true if the constraint stream is guaranteed to only produce distinct tuples.
    `String` | `toString()` |

    - ### Methods inherited from class org.optaplanner.core.impl.score.stream.drools.quad.DroolsAbstractQuadConstraintStream

      `filter, flattenLast, groupBy, groupBy, groupBy, groupBy, groupBy, groupBy, groupBy, groupBy, groupBy, groupBy, groupBy, groupBy, groupBy, groupBy, ifExists, ifNotExists, impactScore, impactScore, impactScoreBigDecimal, impactScoreConfigurable, impactScoreConfigurable, impactScoreConfigurableBigDecimal, impactScoreConfigurableLong, impactScoreLong, map`

    - ### Methods inherited from class org.optaplanner.core.impl.score.stream.drools.common.DroolsAbstractConstraintStream

      `addChildStream, buildConstraint, buildConstraintConfigurable, getChildStreams, getConstraintFactory`

    - ### Methods inherited from class org.optaplanner.core.impl.score.stream.common.AbstractConstraintStream

      `buildConstraintWeightExtractor, buildConstraintWeightExtractor, impact, penalize, penalizeConfigurable, reward, rewardConfigurable`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.optaplanner.core.api.score.stream.ConstraintStream

      `getConstraintFactory, impact, impact, penalize, penalize, penalizeConfigurable, penalizeConfigurable, reward, reward, rewardConfigurable, rewardConfigurable`

    - ### Methods inherited from interface org.optaplanner.core.impl.score.stream.quad.InnerQuadConstraintStream

      `distinct, impact, impactBigDecimal, impactConfigurable, impactConfigurableBigDecimal, impactConfigurableLong, impactLong, penalize, penalizeBigDecimal, penalizeConfigurable, penalizeConfigurableBigDecimal, penalizeConfigurableLong, penalizeLong, reward, rewardBigDecimal, rewardConfigurable, rewardConfigurableBigDecimal, rewardConfigurableLong, rewardLong`

    - ### Methods inherited from interface org.optaplanner.core.api.score.stream.quad.QuadConstraintStream

      `ifExists, ifExists, ifExists, ifExists, ifNotExists, ifNotExists, ifNotExists, ifNotExists, impact, impactBigDecimal, impactConfigurable, impactConfigurableBigDecimal, impactConfigurableLong, impactLong, penalize, penalizeBigDecimal, penalizeConfigurable, penalizeConfigurableBigDecimal, penalizeConfigurableLong, penalizeLong, reward, rewardBigDecimal, rewardConfigurable, rewardConfigurableBigDecimal, rewardConfigurableLong, rewardLong`

- - ### Constructor Detail

    - #### DroolsGroupingQuadConstraintStream

          public DroolsGroupingQuadConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory,
                                                    DroolsAbstractUniConstraintStream<Solution_,​A> parent,
                                                    Function<A,​NewA> groupKeyAMapping,
                                                    UniConstraintCollector<A,​?,​NewB> collectorB,
                                                    UniConstraintCollector<A,​?,​NewC> collectorC,
                                                    UniConstraintCollector<A,​?,​NewD> collectorD)

    - #### DroolsGroupingQuadConstraintStream

          public DroolsGroupingQuadConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory,
                                                    DroolsAbstractBiConstraintStream<Solution_,​A,​B> parent,
                                                    BiFunction<A,​B,​NewA> groupKeyAMapping,
                                                    BiConstraintCollector<A,​B,​?,​NewB> collectorB,
                                                    BiConstraintCollector<A,​B,​?,​NewC> collectorC,
                                                    BiConstraintCollector<A,​B,​?,​NewD> collectorD)

    - #### DroolsGroupingQuadConstraintStream

          public DroolsGroupingQuadConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory,
                                                    DroolsAbstractTriConstraintStream<Solution_,​A,​B,​C> parent,
                                                    TriFunction<A,​B,​C,​NewA> groupKeyAMapping,
                                                    TriConstraintCollector<A,​B,​C,​?,​NewB> collectorB,
                                                    TriConstraintCollector<A,​B,​C,​?,​NewC> collectorC,
                                                    TriConstraintCollector<A,​B,​C,​?,​NewD> collectorD)

    - #### DroolsGroupingQuadConstraintStream

          public DroolsGroupingQuadConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory,
                                                    DroolsAbstractQuadConstraintStream<Solution_,​A,​B,​C,​D> parent,
                                                    QuadFunction<A,​B,​C,​D,​NewA> groupKeyAMapping,
                                                    QuadConstraintCollector<A,​B,​C,​D,​?,​NewB> collectorB,
                                                    QuadConstraintCollector<A,​B,​C,​D,​?,​NewC> collectorC,
                                                    QuadConstraintCollector<A,​B,​C,​D,​?,​NewD> collectorD)

    - #### DroolsGroupingQuadConstraintStream

          public DroolsGroupingQuadConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory,
                                                    DroolsAbstractUniConstraintStream<Solution_,​A> parent,
                                                    Function<A,​NewA> groupKeyAMapping,
                                                    Function<A,​NewB> groupKeyBMapping,
                                                    UniConstraintCollector<A,​?,​NewC> collectorC,
                                                    UniConstraintCollector<A,​?,​NewD> collectorD)

    - #### DroolsGroupingQuadConstraintStream

          public DroolsGroupingQuadConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory,
                                                    DroolsAbstractBiConstraintStream<Solution_,​A,​B> parent,
                                                    BiFunction<A,​B,​NewA> groupKeyAMapping,
                                                    BiFunction<A,​B,​NewB> groupKeyBMapping,
                                                    BiConstraintCollector<A,​B,​?,​NewC> collectorC,
                                                    BiConstraintCollector<A,​B,​?,​NewD> collectorD)

    - #### DroolsGroupingQuadConstraintStream

          public DroolsGroupingQuadConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory,
                                                    DroolsAbstractTriConstraintStream<Solution_,​A,​B,​C> parent,
                                                    TriFunction<A,​B,​C,​NewA> groupKeyAMapping,
                                                    TriFunction<A,​B,​C,​NewB> groupKeyBMapping,
                                                    TriConstraintCollector<A,​B,​C,​?,​NewC> collectorC,
                                                    TriConstraintCollector<A,​B,​C,​?,​NewD> collectorD)

    - #### DroolsGroupingQuadConstraintStream

          public DroolsGroupingQuadConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory,
                                                    DroolsAbstractQuadConstraintStream<Solution_,​A,​B,​C,​D> parent,
                                                    QuadFunction<A,​B,​C,​D,​NewA> groupKeyAMapping,
                                                    QuadFunction<A,​B,​C,​D,​NewB> groupKeyBMapping,
                                                    QuadConstraintCollector<A,​B,​C,​D,​?,​NewC> collectorC,
                                                    QuadConstraintCollector<A,​B,​C,​D,​?,​NewD> collectorD)

    - #### DroolsGroupingQuadConstraintStream

          public DroolsGroupingQuadConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory,
                                                    DroolsAbstractUniConstraintStream<Solution_,​A> parent,
                                                    Function<A,​NewA> groupKeyAMapping,
                                                    Function<A,​NewB> groupKeyBMapping,
                                                    Function<A,​NewC> groupKeyCMapping,
                                                    UniConstraintCollector<A,​?,​NewD> collectorD)

    - #### DroolsGroupingQuadConstraintStream

          public DroolsGroupingQuadConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory,
                                                    DroolsAbstractBiConstraintStream<Solution_,​A,​B> parent,
                                                    BiFunction<A,​B,​NewA> groupKeyAMapping,
                                                    BiFunction<A,​B,​NewB> groupKeyBMapping,
                                                    BiFunction<A,​B,​NewC> groupKeyCMapping,
                                                    BiConstraintCollector<A,​B,​?,​NewD> collectorD)

    - #### DroolsGroupingQuadConstraintStream

          public DroolsGroupingQuadConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory,
                                                    DroolsAbstractTriConstraintStream<Solution_,​A,​B,​C> parent,
                                                    TriFunction<A,​B,​C,​NewA> groupKeyAMapping,
                                                    TriFunction<A,​B,​C,​NewB> groupKeyBMapping,
                                                    TriFunction<A,​B,​C,​NewC> groupKeyCMapping,
                                                    TriConstraintCollector<A,​B,​C,​?,​NewD> collectorD)

    - #### DroolsGroupingQuadConstraintStream

          public DroolsGroupingQuadConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory,
                                                    DroolsAbstractQuadConstraintStream<Solution_,​A,​B,​C,​D> parent,
                                                    QuadFunction<A,​B,​C,​D,​NewA> groupKeyAMapping,
                                                    QuadFunction<A,​B,​C,​D,​NewB> groupKeyBMapping,
                                                    QuadFunction<A,​B,​C,​D,​NewC> groupKeyCMapping,
                                                    QuadConstraintCollector<A,​B,​C,​D,​?,​NewD> collectorD)

    - #### DroolsGroupingQuadConstraintStream

          public DroolsGroupingQuadConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory,
                                                    DroolsAbstractUniConstraintStream<Solution_,​A> parent,
                                                    Function<A,​NewA> groupKeyAMapping,
                                                    Function<A,​NewB> groupKeyBMapping,
                                                    Function<A,​NewC> groupKeyCMapping,
                                                    Function<A,​NewD> groupKeyDMapping)

    - #### DroolsGroupingQuadConstraintStream

          public DroolsGroupingQuadConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory,
                                                    DroolsAbstractBiConstraintStream<Solution_,​A,​B> parent,
                                                    BiFunction<A,​B,​NewA> groupKeyAMapping,
                                                    BiFunction<A,​B,​NewB> groupKeyBMapping,
                                                    BiFunction<A,​B,​NewC> groupKeyCMapping,
                                                    BiFunction<A,​B,​NewD> groupKeyDMapping)

    - #### DroolsGroupingQuadConstraintStream

          public DroolsGroupingQuadConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory,
                                                    DroolsAbstractTriConstraintStream<Solution_,​A,​B,​C> parent,
                                                    TriFunction<A,​B,​C,​NewA> groupKeyAMapping,
                                                    TriFunction<A,​B,​C,​NewB> groupKeyBMapping,
                                                    TriFunction<A,​B,​C,​NewC> groupKeyCMapping,
                                                    TriFunction<A,​B,​C,​NewD> groupKeyDMapping)

    - #### DroolsGroupingQuadConstraintStream

          public DroolsGroupingQuadConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory,
                                                    DroolsAbstractQuadConstraintStream<Solution_,​A,​B,​C,​D> parent,
                                                    QuadFunction<A,​B,​C,​D,​NewA> groupKeyAMapping,
                                                    QuadFunction<A,​B,​C,​D,​NewB> groupKeyBMapping,
                                                    QuadFunction<A,​B,​C,​D,​NewC> groupKeyCMapping,
                                                    QuadFunction<A,​B,​C,​D,​NewD> groupKeyDMapping)

    - #### DroolsGroupingQuadConstraintStream

          public DroolsGroupingQuadConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory,
                                                    DroolsAbstractUniConstraintStream<Solution_,​A> parent,
                                                    UniConstraintCollector<A,​?,​NewA> collectorA,
                                                    UniConstraintCollector<A,​?,​NewB> collectorB,
                                                    UniConstraintCollector<A,​?,​NewC> collectorC,
                                                    UniConstraintCollector<A,​?,​NewD> collectorD)

    - #### DroolsGroupingQuadConstraintStream

          public DroolsGroupingQuadConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory,
                                                    DroolsAbstractBiConstraintStream<Solution_,​A,​B> parent,
                                                    BiConstraintCollector<A,​B,​?,​NewA> collectorA,
                                                    BiConstraintCollector<A,​B,​?,​NewB> collectorB,
                                                    BiConstraintCollector<A,​B,​?,​NewC> collectorC,
                                                    BiConstraintCollector<A,​B,​?,​NewD> collectorD)

    - #### DroolsGroupingQuadConstraintStream

          public DroolsGroupingQuadConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory,
                                                    DroolsAbstractTriConstraintStream<Solution_,​A,​B,​C> parent,
                                                    TriConstraintCollector<A,​B,​C,​?,​NewA> collectorA,
                                                    TriConstraintCollector<A,​B,​C,​?,​NewB> collectorB,
                                                    TriConstraintCollector<A,​B,​C,​?,​NewC> collectorC,
                                                    TriConstraintCollector<A,​B,​C,​?,​NewD> collectorD)

    - #### DroolsGroupingQuadConstraintStream

          public DroolsGroupingQuadConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory,
                                                    DroolsAbstractQuadConstraintStream<Solution_,​A,​B,​C,​D> parent,
                                                    QuadConstraintCollector<A,​B,​C,​D,​?,​NewA> collectorA,
                                                    QuadConstraintCollector<A,​B,​C,​D,​?,​NewB> collectorB,
                                                    QuadConstraintCollector<A,​B,​C,​D,​?,​NewC> collectorC,
                                                    QuadConstraintCollector<A,​B,​C,​D,​?,​NewD> collectorD)

  - ### Method Detail

    - #### guaranteesDistinct

          public boolean guaranteesDistinct()

      Description copied from interface: `InnerQuadConstraintStream`
      This method will return true if the constraint stream is guaranteed to only produce distinct tuples. See `InnerQuadConstraintStream.distinct()` for details.
      Returns:
        true if the guarantee of distinct tuples is provided

    - #### getLeftHandSide

          public QuadLeftHandSide<NewA,​NewB,​NewC,​NewD> getLeftHandSide()

      Specified by:
        `getLeftHandSide` in class `DroolsAbstractQuadConstraintStream<Solution_,​NewA,​NewB,​NewC,​NewD>`

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`